/*
 * AES for HW-A03
 *
 * Copyright (C) 2016 SHARP.Co.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/*
 * aes.h
 *
 *  Created on: 2015/03/04
 */

#ifndef _AES_INCLUDED
#define _AES_INCLUDED

#include <common.h>

typedef unsigned int intptr_t;


// #define the macros below to 1/0 to enable/disable the mode of operation.
//
// CBC enables AES128 encryption in CBC-mode of operation and handles 0-padding.
// ECB enables the basic ECB 16-byte block algorithm. Both can be enabled simultaneously.

// The #ifndef-guard allows it to be configured before #include'ing or at compile time.
#ifndef CBC
  #define CBC 1
#endif

#ifndef ECB
  #define ECB 1
#endif



#if defined(ECB) && ECB

void AES128_ECB_encrypt(u8* input, const u8* key, u8 *output);
void AES128_ECB_decrypt(u8* input, const u8* key, u8 *output);

#endif // #if defined(ECB) && ECB


#if defined(CBC) && CBC

void AES128_CBC_encrypt_buffer(u8* output, u8* input, u32 length, const u8* key, const u8* iv);
void AES128_CBC_decrypt_buffer(u8* output, u8* input, u32 length, const u8* key, const u8* iv);

#endif // #if defined(CBC) && CBC



#endif //_AES_INCLUDED
