/*
 * DCT for HW-A03
 *
 * Copyright (C) 2016 SHARP.Co.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#ifndef INC_DCT_H_
#define INC_DCT_H_

#include <common.h>


#define DCT_MAGIC	(0x53414354L)

struct platform_dct_header {
	u32	full_size;
	u32	used_size;
	u8		write_incomplete;
	u8		is_current_dct;
	u32	magic_number;
	u8		reserved[18];
} __attribute__((__packed__));
typedef struct platform_dct_header platform_dct_header_t;


#define DCT_BOOT_STATE_UPDATE		(1 << 2)
#define DCT_BOOT_STATE_RESCUE		(1 << 4)
#define DCT_BOOT_STATE_HALT			(1 << 6)

union hms_boot_state_s {
	unsigned char data;
	struct {
		unsigned char reserved0:2;
		unsigned char update:1;
		unsigned char reserved1:1;
		unsigned char rescue:1;
		unsigned char reserved2:1;
		unsigned char halt:1;
		unsigned char reserved3:1;
	} bit;
} __attribute__((__packed__));
typedef union hms_boot_state_s hms_boot_state_t;

struct platform_dct_btldr {
	u32			used_size;
	hms_boot_state_t	hms_boot_state;
	u8				hms_update_retry_cnt;
	u8				reserved[122];
} __attribute__((__packed__));
typedef struct platform_dct_btldr platform_dct_btldr_t;

typedef	struct	dct_header{
	platform_dct_header_t	p_dct_header;
	platform_dct_btldr_t	p_dct_btldt;
} dct_header_t;

typedef enum MODE{
	NORMAL_MODE,
	RESCUE_HALT_MODE,
	RESCUE_MODE,
	UPDATER_MODE,
	RESET_MODE,
	HALT_FLAG_RESET,
	RESCUE_FLAG_RESET,
	UPDATE_FLAG_RESET
}START_MODE;

#endif /* INC_DCT_H_ */
