/*
 * FFS for HW-A03
 *
 * Copyright (C) 2016 SHARP.Co.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#ifndef INC_FFS_H_
#define INC_FFS_H_

#include <common.h>

/* state */
#define FFS_STATE_UNUSED			(0xffffffffL)	/* 未使用 */
#define FFS_STATE_WRITING			(0xffffff00L)	/* 書き込み中 */
#define FFS_STATE_USED				(0xffff0000L)	/* 使用中 */
#define FFS_STATE_REFUGE			(0xff000000L)	/* 書込み回数退避中 */
#define FFS_STATE_INVALID			(0x00000000L)	/* 使用不可 */

/* code */
#define FFS_CODE_WIFI				(0xf0005257L)	/* WIFIファームウェア */
#define FFS_CODE_APPLI				(0xf0005241L)	/* APPLIファームウェア */
#define FFS_CODE_LINUX				(0xf000524cL)	/* Linuxファームウェア */

#define FFS_BLOCK_SIZE	(1024 * 60)		/* 60KB */

struct ffs_header {
	u16	count;
	u32	state;
	u32	code;
} __attribute__((__packed__));
typedef struct ffs_header ffs_header_t;

struct ffs_info {
	u32	start_date;
	u32	end_date;
	u32	start_time;
	u32	end_time;
	u32	next_code;
	u32	revision;
	u8		id[12];
	u16	size;
	u8		probability;
	u8		reserve;
} __attribute__((__packed__));
typedef struct ffs_info ffs_info_t;

struct ffs_reserve {
	u8		reserve_1;
	u32	reserve_2;
	u32	reserve_3;
} __attribute__((__packed__));
typedef struct ffs_reserve ffs_reserve_t;

struct ffs_blkinfo {
	u16	next_blk;
} __attribute__((__packed__));
typedef struct ffs_blkinfo ffs_blkinfo_t;

struct ffs_block {
	ffs_header_t	ffs_header;
	ffs_info_t		ffs_info;
	ffs_reserve_t	ffs_reserve;
	ffs_blkinfo_t	ffs_blkinfo;
	u8			reserve[4035];
	u8			ffs_data[FFS_BLOCK_SIZE];
} __attribute__((__packed__));
typedef struct ffs_block ffs_block_t;

#endif /* INC_FFS_H_ */
