/*
 * ROM Image for HW-A03
 *
 * Copyright (C) 2016 SHARP.Co.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#ifndef INC_ROM_IMAGE_H_
#define INC_ROM_IMAGE_H_

#define	MD5_HASH_SIZE								(16)
#define	UPDATE_HEADER_HEADDER_STRING				"SHARP_HW-A03"
#define	UPDATE_HEADER_IMAGE_VERSION					(0x0002)
#define	UPDATE_HEADER_TYPE_CODE_LINUX_CPU_IMAGE		(0x0003)
#define	UPDATE_HEADER_CHUNK_LINUX_CPU_IMAGE			"UD3L"

#define RESCUE_HEADER_TYPE_CODE_RESCUE_IMAGE		(0xF003)
#define	UPDATE_HEADER_CHUNK_RESCUE_IMAGE			"RA3L"

struct image_files {
	const char *updater;
	const char *devicetree;
	const char *kernel;
	const char *rootfs;
	const char *exsystem;
	const char *dct;
};

struct	rom_image_header{
	u8		header_image_type[16];
	u16	image_version;
	u16	type_code;
	u8		reserved_1[4];
	u32	size;
	u8		hash[MD5_HASH_SIZE];
	u8		reserved_2[208];
	u32	next_headder;
} __attribute__((__packed__));
typedef struct rom_image_header rom_image_header_t;

struct	linux_image_header{
	u8		chunk_type[4];
	u32	version;
	u32	updater_size;
	u8		updater_hash[MD5_HASH_SIZE];
	u32	devicetree_size;
	u8		devicetree_hash[MD5_HASH_SIZE];
	u32	kernel_size;
	u8		kernel_hash[MD5_HASH_SIZE];
	u32	rfs_size;
	u8		rfs_hash[MD5_HASH_SIZE];
	u32	exsystem_size;
	u8		exsystem_hash[MD5_HASH_SIZE];
	u32	dct_size;
	u8		dct_hash[MD5_HASH_SIZE];
} __attribute__((__packed__));
typedef struct linux_image_header linux_image_header_t;

typedef	struct	file_header{
	rom_image_header_t rom_image_hdr;
	linux_image_header_t linux_image_hdr;
} file_header_t;

/* Rescue image header */
struct	rescue_image_header{
	u8		chunk_type[4];
	u32		version;
	u32		rescue_size;
	u8		rescue_hash[MD5_HASH_SIZE];
	u8		reserved_1[36];
} __attribute__((__packed__));
typedef struct rescue_image_header rescue_image_header_t;

typedef	struct	rescue_file_header {
	rom_image_header_t rom_image_hdr;
	rescue_image_header_t rescue_image_hdr;
} rescue_file_header_t;
/* Rescue image header */

#endif /* INC_ROM_IMAGE_H_ */
