/*
 * Updater for HW-A03
 *
 * Copyright (C) 2016 SHARP.Co.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * md5 for UPDATER
 * <pre>
 *  md5の処理を行う
 * </pre>
 * @version 0.01
*/

#include "updater.h"
#include "rom_image.h"
#include "md5.h"


/**
 * @brief MD5 Hash作成処理
 * @attention なし
 * @note MD5 Hash処理を行う。
 * @param [OUT] hash
 * @param [IN] address
 * @param [IN] size
 * @return True/False
 */
int	updater_md5_hash(u8 *hash,u8 *data,int size)
{
	MD5_CTX ctx;
	int loop;

	for (loop = 0; loop < MD5_HASH_SIZE; loop++) {
		hash[loop] = 0;
	}
	MD5_Init(&ctx);
	MD5_Update(&ctx,data,size);
	MD5_Final(hash,&ctx);

	return UPDATER_TRUE;
}

/**
 * @brief MD5 Hash作成処理
 * @attention なし
 * @note MD5 Hash処理を行う。
 * @param [OUT] hash
 * @param [IN] address
 * @param [IN] size
 * @return True/False
 */
int	updater_md5_hash_check(u8 *hash,u8 *comp)
{
	int loop;
	int result;

	result = UPDATER_TRUE;
	for (loop = 0; loop < MD5_HASH_SIZE; loop++) {
		if (*hash++ != *comp++) {
			result = UPDATER_FALSE;
			break;
		}
	}

	return result;
}
