#!/bin/bash
#
# AES for HW-A03
#
# Copyright (C) 2016 SHARP.Co.
#

FILE_A03_CONFIG="./a03_config.txt"
FILE_A03_VERSION="./a03_version.txt"

NEXT_X=0
NEXT_Y=0
NEXT_Z=0
RELEASE_COUNT=0
BUILD_COUNT=0
NEXT_COUNT=0

update_a03_config () {
	#echo "Next   : X=${NEXT_X} Y=${NEXT_Y} Z=${NEXT_Z}"
	echo "X=${NEXT_X}"  >  ${FILE_A03_CONFIG}
	echo "Y=${NEXT_Y}"  >> ${FILE_A03_CONFIG}
	echo "Z=${NEXT_Z}"  >> ${FILE_A03_CONFIG}
	if [ ${AUTO} -eq 1 ]; then
		echo "AUTO=${AUTO}" >> ${FILE_A03_CONFIG}
	fi
}

if [ -e ${FILE_A03_CONFIG} ]; then
	source ${FILE_A03_CONFIG}
fi

#echo "Read   : X=${X} Y=${Y} Z=${Z}"

if [ -z "${X}" ]; then
	X=0
fi
if [ -z "${AUTO}" ]; then
	AUTO=0
fi

if [ ${X} -eq 1 ]; then
	# Release Version

	if [ -z "${Y}" ]; then
		Y=0
	fi

	if [ -z "${Z}" ]; then
		Z=0
	fi

	RELEASE_COUNT=${Z}

	# if (RELEASE_COUNT < 0 || RELEASE_COUNT > 65535)
	#     RELEASE_COUNT=0
	if [ ${RELEASE_COUNT} -lt 0 ] || [ ${RELEASE_COUNT} -gt 65535 ]; then
		RELEASE_COUNT=0
	fi

	Z=${RELEASE_COUNT}

	if [ ${AUTO} -eq 1 ]; then
		# NEXT_COUNT = RELEASE_COUNT + 1
		# if (NEXT_COUNT < 0 || NEXT_COUNT > 65535)
		#     NEXT_COUNT=0
		NEXT_COUNT=`expr ${RELEASE_COUNT} + 1`
		if [ ${NEXT_COUNT} -lt 0 ] || [ ${NEXT_COUNT} -gt 65535 ]; then
			NEXT_COUNT=0
		fi

		NEXT_X=${X}
		NEXT_Y=${Y}
		NEXT_Z=${NEXT_COUNT}

		update_a03_config
	fi
else
	# Debug Version

	X=0

	if [ -n "${Y}" ]; then
		CONFIG_YEAR=${Y}
	else
		CONFIG_YEAR=`date '+%y'`
	fi

	if [ -n "${Z}" ]; then
		CONFIG_DATE=`expr ${Z} / 10`
		CONFIG_DATE=$(printf "%04d" ${CONFIG_DATE})
		BUILD_COUNT=`expr ${Z} % 10`
	else
		CONFIG_DATE=`date '+%m%d'`
		BUILD_COUNT=1
	fi

	# if (CONFIG_YEAR < 0 || CONFIG_YEAR > 99)
	#     CONFIG_YEAR=`date '+%y'`
	if [ ${CONFIG_YEAR} -lt 0 ] || [ ${CONFIG_YEAR} -gt 99 ]; then
		CONFIG_YEAR=`date '+%y'`
	fi

	# if (CONFIG_DATE < 0 || CONFIG_DATE > 9999)
	#     CONFIG_DATE=`date '+%m%d'`
	if [ ${CONFIG_DATE} -lt 0 ] || [ ${CONFIG_DATE} -gt 9999 ]; then
		CONFIG_DATE=`date '+%m%d'`
	fi

	# if (BUILD_COUNT < 1 || BUILD_COUNT > 9)
	#     BUILD_COUNT=1
	if [ ${BUILD_COUNT} -lt 1 ] || [ ${BUILD_COUNT} -gt 9 ]; then
		BUILD_COUNT=1
	fi

	#echo "CONFIG_YEAR=${CONFIG_YEAR}"
	#echo "CONFIG_DATE=${CONFIG_DATE}"
	#echo "BUILD_COUNT=${BUILD_COUNT}"

	if [ ${AUTO} -eq 1 ]; then
		OLD="${CONFIG_YEAR}${CONFIG_DATE}"

		YEAR=`date '+%y'`
		DATE=`date '+%m%d'`
		NEW="${YEAR}${DATE}"

		#echo "OLD=${OLD} NEW=${NEW}"
		if [ "${OLD}" != "${NEW}" ]; then
			BUILD_COUNT=1
		fi

		Y=${YEAR}
		Z=`expr ${DATE} \* 10`
		Z=`expr ${Z} + ${BUILD_COUNT}`

		# NEXT_COUNT = BUILD_COUNT + 1
		# if (NEXT_COUNT < 1 || NEXT_COUNT > 9)
		#     NEXT_COUNT=1
		NEXT_COUNT=`expr ${BUILD_COUNT} + 1`
		if [ ${NEXT_COUNT} -lt 1 ] || [ ${NEXT_COUNT} -gt 9 ]; then
			NEXT_COUNT=1
		fi

		NEXT_X=${X}
		NEXT_Y=$(printf "%02d" ${Y})
		NEXT_Z=`expr ${DATE} \* 10`
		NEXT_Z=`expr ${NEXT_Z} + ${NEXT_COUNT}`
		NEXT_Z=$(printf "%05d" ${NEXT_Z})

		update_a03_config
	else
		Y=${CONFIG_YEAR}
		Z=`expr ${CONFIG_DATE} \* 10`
		Z=`expr ${Z} + ${BUILD_COUNT}`

		if [ ! -e ${FILE_A03_CONFIG} ]; then
			NEXT_X=${X}
			NEXT_Y=$(printf "%02d" ${Y})
			NEXT_Z=$(printf "%05d" ${Z})

			update_a03_config
		fi;
	fi
fi

ZL=$((Z & 0xff))
ZH=$((Z & 0xff00))
ZH=$((ZH >> 8))

VERSION=$(printf "0x%02x%02x%02x%02x" ${ZL} ${ZH} ${Y} ${X})

#echo "Current: X=${X} Y=${Y} Z=${Z}"

if [ ${X} -eq 1 ]; then
	VERSION_STRING=$(printf "%d.%d.%d" ${X} ${Y} ${Z})
else
	VERSION_STRING=$(printf "%d.%02d.%05d" ${X} ${Y} ${Z})
fi

echo "VERSION_STRING: ${VERSION_STRING}" >  ${FILE_A03_VERSION}
echo "VERSION_CODE  : ${VERSION}"        >> ${FILE_A03_VERSION}

echo "${VERSION}"

exit 0
